﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Dynamicweb.Ecommerce.LiveIntegration.Configuration
{
    internal class Constants
    {
        public const string AddInName = "ERPLiveIntegrationAddIn";

        public static readonly string WebServiceConnectionCacheKey = AddInName + "_WebServiceConnectionCacheKey";

        public static readonly string ANONYMOUS_USER_NAME = "Anonymous";

        internal class WebServiceConfiguration
        {
            public static readonly string Path = "WebService";
            public static readonly string Shop = "Shop";
            public static readonly string Url = "Url";
            public static readonly string SecurityKey = "SecurityKey";
            public static readonly string DiscountText= "DiscountText";
            public static readonly string WebSeviceConnectionStatusGlobalTagName = "WebSeviceConnectionStatusGlobalTagName";            
            public static readonly string AllowIntegrationForAnonymousUsers = "AllowIntegrationForAnonymousUsers";
            public static readonly string DisableLiveIntegrationOnProductCatalog = "DisableLiveIntegrationOnProductCatalog";
            public static readonly string NumberFormatCulture = "NumberFormatCulture";
        }

		internal class PriceCalculation
		{
			public static readonly string Path = "Price";
			public static readonly string CalculatePriceUsingProductNumber = "CalculatePriceUsingProductNumber";
		}

		internal class CacheConfiguration
        {
            public static readonly string Path = "Cache";            
            public static readonly string Product = "Product";
            public static readonly string Order = "Order";
        }

        internal class ErrorHandlingConfiguration
        {
            public static readonly string Path = "ErrorHandling";
            public static readonly string LogConnectionErrors = "LogConnectionErrors";
            public static readonly string LogResponseErrors = "LogResponseErrors";
            public static readonly string LogGeneralErrors = "LogGeneralErrors";
            public static readonly string LogDebugInfo = "LogDebugInfo";
            public static readonly string LogMaxSize = "LogMaxSize";
        }

        internal class NotificationSettings
        {
            public static readonly string Path = "NotificationSettings";
            public static readonly string NotificationEmail = "NotificationEmail";
            public static readonly string NotificationTemplate = "NotificationTemplate";
            public static readonly string NotificationEmailSubject = "NotificationEmailSubject";
            public static readonly string NotificationEmailSenderName = "NotificationEmailSenderName";
            public static readonly string NotificationEmailSenderEmail = "NotificationEmailSenderEmail";
            public static readonly string NotificationSendingFrequency = "NotificationSendingFrequency";
            public static readonly string NotificationLastSendTime = "NotificationLastSendTime";
        }

        internal class CustomFieldsSettings
        {
            public static readonly string Path = "CustomFieldsSettings";
            public static readonly string AddOrderFieldsToRequest = "AddOrderFieldsToRequest";
            public static readonly string AddOrderLineFieldsToRequest = "AddOrderLineFieldsToRequest";
            public static readonly string AddProductFieldsToRequest = "AddProductFieldsToRequest";
            public static readonly string AllowMultipleContactsPerCompany  = "AllowMultipleContactsPerCompany";
            
        }

        internal class OrderSettings
        {
            public static readonly string Path = "OrderSettings";
            public static readonly string OrderStateAfterExport = "OrderStateAfterExport";
            public static readonly string OrderStateAfterExportFailed = "OrderStateAfterExportFailed";
        }
    }
}
