﻿using System.Web;
using Dynamicweb;
using Dynamicweb.Ecommerce.LiveIntegration.Configuration;
using Dynamicweb.Extensibility.Notifications;
using System;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    [Subscribe(Dynamicweb.Notifications.Standard.Page.Loaded)]
    public class PageOnLoadObserver : NotificationSubscriber
    {
        public override void OnNotify(string notification, NotificationArgs args)
        {
            if (HttpContext.Current != null && HttpContext.Current.Session != null &&
                Convert.ToBoolean(HttpContext.Current.Session["LiveIntegration.OrderExportFailed"]))
            {
                Dynamicweb.Notifications.Standard.Page.LoadedArgs loadedArgs = args as Dynamicweb.Notifications.Standard.Page.LoadedArgs;
                if (loadedArgs != null && loadedArgs.pageview != null && loadedArgs.pageview.Template!= null)
                {
                    loadedArgs.pageview.Template.SetTag("LiveIntegration.OrderExportFailed", true);
                    loadedArgs.pageview.Template.SetTag("LiveIntegration.FailedOrderID", Convert.ToString(HttpContext.Current.Session["LiveIntegration.FailedOrderID"]));
                }
            }
        }
    }
}
