﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Dynamicweb.Extensibility;
using Dynamicweb.Modules.UserManagement;
using Dynamicweb.Ecommerce.Products;
using Dynamicweb.Ecommerce.Integration;
using Dynamicweb.Ecommerce.LiveIntegration.Configuration;
using Dynamicweb.Extensibility.Notifications;
using Dynamicweb.Security.UserManagement;

namespace Dynamicweb.Ecommerce.LiveIntegration.NotificationSubscribers
{
    [Subscribe(Dynamicweb.Ecommerce.Notifications.Ecommerce.ProductList.BeforeSort)]
    public class ProductListBeforeSort : NotificationSubscriber
    {
        public override void OnNotify(string notification, NotificationArgs args)
        {
            if (!Configuration.Global.IsIntegrationActive)
                return;
            var user = User.GetCurrentExtranetUser();
            if (!Configuration.Global.IsIntegrationForAnonymousUsersAllowed && user == null)
                return;

            if (user != null && user.IsLivePricesDisabled)
                return;

            if (!UrlHandler.Instance.IsWebServiceUrlFound())
                return;

            var myArgs = (Dynamicweb.Ecommerce.Notifications.Ecommerce.ProductList.BeforeSortArgs)args;

            // Set product info
            if (string.IsNullOrEmpty(Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop)) ||
    Helpers.GetConfigValue(Constants.WebServiceConfiguration.Path, Constants.WebServiceConfiguration.Shop) == (String)Dynamicweb.Frontend.PageView.Current().Area.EcomShopId)
            {

                SetProductInfo(myArgs);
            }
        }

        private void SetProductInfo(Dynamicweb.Ecommerce.Notifications.Ecommerce.ProductList.BeforeSortArgs args)
        {            
            PrepareProductInfoProvider.FetchProductInfos(args.Products.ToList());

            // Set values
            foreach (Product product in args.Products)
            {
                PrepareProductInfoProvider.FillProductValues(product);
            }
        }
    }
}
